## $Id: test_document.py 12371 2015-01-03 07:38:07Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Tests for pcn documents.
"""
from zope.interface.verify import verifyClass, verifyObject
from zope.component import createObject
from waeup.ikoba.documents.container import DocumentsContainer

from ikobacustom.pcn.testing import (FunctionalLayer, FunctionalTestCase)
from ikobacustom.pcn.documents.document import PCNDocument
from ikobacustom.pcn.documents.interfaces import IPCNDocument

class PCNDocumentTestCase(FunctionalTestCase):

    layer = FunctionalLayer

    def test_interfaces(self):
        # Make sure the correct interfaces are implemented.
        self.assertTrue(
            verifyClass(
                IPCNDocument, PCNDocument)
            )
        self.assertTrue(
            verifyObject(
                IPCNDocument, PCNDocument())
            )
        return

    def test_addPCNDocument(self):
        container = DocumentsContainer()
        document = createObject(u'waeup.PCNDocument')
        document.document_id = u'DOC1'
        container.addDocument(document)
        self.assertRaises(TypeError, container.addDocument, object())
        self.assertEqual(document.document_id, 'DOC1')
        self.assertEqual(container['DOC1'], document)
        return
